import {select,csv,scaleLinear,max,scaleBand,axisLeft,axisBottom,format,count
	     } from 'd3';

// ====== DATA INPUT =============

  csv("data.csv").then(function(data){
        	data.forEach(function(d){
          d.Ages = +d.Ages;
          d["User ID"] = +d["User ID"];
          d["Year of Birth"] = +d["Year of Birth"];
    });
    
 	var panel = data.length
  console.log(rowTotal);
    
    	var render1 = data => {    
      	var regionGrp = d3.nest()
          .key(function(d) {return d.Region;})
          .rollup(function(val) {return Math.floor(val.length/panel * 100);})
          .entries(data); 
			 
        render1(regionGrp); 

}


// < ===============  Charts  ========== >

  var svg = select('svg');
  var height = +svg.attr('height');
  var width = +svg.attr('width');
    
   var xValue = d => d.value;
      var yValue = d => d.key;
	    var margin = {top: 50, right: 200, bottom: 50, left: 200};
	    var innerWidth = width - margin.left - margin.right;
      var innerHeight = height - margin.top - margin.bottom;
      var xScale = scaleLinear()
  	      .domain([0, max(data, xValue)])
  	      .range([0, innerWidth]);
      var yScale = scaleBand()
  	      .domain(data.map(yValue))
  	      .range([0, innerHeight])
  	      .padding(0.1);
     var g = svg.append('g')
  	     .attr('transform', `translate(${margin.left},${margin.top})`);
     var yAxis = axisLeft(yScale);
	var xAxis = axisBottom(xScale)
   	    .tickFormat(function(d) {return d + " %"})

   yAxis(g.append('g'));

	 g.selectAll('rect')
    	.data(data)
  		.enter()
    	.append('rect')
  		.attr('y', d => yScale(yValue(d)))
  		.attr('width', d => xScale(xValue(d)))
  		.attr('height', yScale.bandwidth());

   svg.append("g")
      .attr("transform", "translate(" + margin.left + "," + margin.top + ")")
      .selectAll(".textlabel")
      .data(data)
      .enter()
      .append("text")
      .attr("class", "textlabel")
      .attr("x", function(d){ return  xScale(parseFloat(d.value))  + 10 ;  })
      .attr("y", function(d){ return yScale(d.key) +  yScale.bandwidth()/2; })
      .text(function(d){ return (d.value) + "%"; });
  };
  
);

